angular.module('gaugesScreen', [])
.controller('GaugesScreenController', function($scope, $window) {
  var unit = null;
  $scope.data = {}
  // overwriting plain javascript function so we can access from within the controller
  $window.updateData = (data) => {
    $scope.$evalAsync(function() {

		const bg = document.getElementById("gaugebg");
		const div = document.getElementById("dategauge");
		const sigl = document.getElementById("signal_l");
		const sigr = document.getElementById("signal_r");
		const fuel = document.getElementById("lowfuel");
		const bat = document.getElementById("battery");
		const evbat = document.getElementById("evbattery");
		const ret = document.getElementById("retarderbar");
		const pwr = document.getElementById("powerbar");
		const chg = document.getElementById("chargebar");
		const evpwr = document.getElementById("evpowerbar");
		const evchg = document.getElementById("evchargebar");
		const rettext = document.getElementById("retardertext");
		const pwrtext = document.getElementById("powertext");
		const chgtext = document.getElementById("chargetext");
		const hbatgauge = document.getElementById("hybridbatgauge");
		const remindcolour = "#CC9900"
		const needledef = "url(/vehicles/capsule/gauges/capsule_gauges_needle.png)"
		const needlered = "url(/vehicles/capsule/gauges/capsule_gauges_needle_red.png)"
		const needleblue = "url(/vehicles/capsule/gauges/capsule_gauges_needle_blue.png)"
		const fuelred = "url(/vehicles/capsule/gauges/capsule_gauges_fuel.png)"
		const fuelwhite = "url(/vehicles/capsule/gauges/capsule_gauges_fuel_white.png)"
		const batred = "url(/vehicles/capsule/gauges/capsule_gauges_bat.png)"
		const batwhite = "url(/vehicles/capsule/gauges/capsule_gauges_bat_white.png)"
		var speedang
		var rpmang = parseInt(-180/3200*data.rpm)
		if (rpmang < -180) {rpmang = -180}
		var fuelang = parseInt(90*data.fuel)
		var evbatang = parseInt(180*data.fuel)
		var tempang
		var pressang = parseInt(-90*55/100)
		var batang = parseInt(90*(24-16)/20)
		var retang = parseInt(225-18*data.state)
		var pwrang
		var chgang
			 
        if (data.enginerunning != 0 ) {
			if (data.gaugeunit == 1) {
				if (data.fueltype == 2) {
					bg.style.backgroundImage = "url(/vehicles/capsule/gauges/capsule_gauges_ev_mi.png)";
				} else {
					bg.style.backgroundImage = "url(/vehicles/capsule/gauges/capsule_gauges_mi.png)";
				}
				$scope.data.speedometergauge = (data.speedometergauge * 0.621371).toFixed(0);
				speedang = parseInt(180/100*$scope.data.speedometergauge);
				tempang = parseInt(-90*((data.watertemp*9/5+32)-90)/180);
				$scope.data.odometer = (data.odometer * 0.621371).toFixed(1) + " mi"
			} else {
				if (data.fueltype == 2) {
					bg.style.backgroundImage = "url(/vehicles/capsule/gauges/capsule_gauges_ev.png)";
				} else {
					bg.style.backgroundImage = "url(/vehicles/capsule/gauges/capsule_gauges.png)";
				}
				$scope.data.speedometergauge = (data.speedometergauge).toFixed(0);
				speedang = parseInt(180/160*$scope.data.speedometergauge);
				tempang = parseInt(-90*(data.watertemp-30)/100);
				$scope.data.odometer = (data.odometer).toFixed(1) + " km"
			}
		if (speedang > 180) {speedang = 180}
		document.getElementById("speed").style.transform = "rotate(" + speedang + "deg)";
		document.getElementById("speedbar").style.transform = "rotate(" + (speedang-135) + "deg)";
		document.getElementById("rpm").style.transform = "rotate(" + rpmang + "deg)";
		document.getElementById("rpmbar").style.transform = "rotate(" + (rpmang+45) + "deg)";
		document.getElementById("fuelneedle").style.transform = "rotate(" + fuelang + "deg)";
		document.getElementById("fuelbar").style.transform = "rotate(" + (fuelang-45) + "deg)";
		if (data.fuel <= 0.1) {
			document.getElementById("fuelneedle").style.backgroundImage = needlered;
			document.getElementById("fuelbar").style.borderLeftColor = "rgba(204,51,0,0.2)";
		} else {
			document.getElementById("fuelneedle").style.backgroundImage = needledef;
			document.getElementById("fuelbar").style.borderLeftColor = "rgba(105,94,152,0.2)";
		}
		document.getElementById("tempneedle").style.transform = "rotate(" + (tempang+180) + "deg)";
		document.getElementById("tempbar").style.transform = "rotate(" + (tempang+225) + "deg)";
		if (data.watertemp >= 100) {
			document.getElementById("tempneedle").style.backgroundImage = needlered;
			document.getElementById("tempbar").style.borderLeftColor = "rgba(204,51,0,0.2)";
		} else if (data.watertemp <= 60) {
			document.getElementById("tempneedle").style.backgroundImage = needleblue;
			document.getElementById("tempbar").style.borderLeftColor = "rgba(51,102,255,0.2)";
		} else {
			document.getElementById("tempneedle").style.backgroundImage = needledef;
			document.getElementById("tempbar").style.borderLeftColor = "rgba(105,94,152,0.2)";
		}
		document.getElementById("pressneedle").style.transform = "rotate(" + (pressang) + "deg)";
		document.getElementById("pressbar").style.transform = "rotate(" + (pressang+45) + "deg)";
			if (data.signal_l == 1 ) {sigl.style.visibility = "visible"} else {sigl.style.visibility = "hidden"}
			if (data.signal_r == 1 ) {sigr.style.visibility = "visible"} else {sigr.style.visibility = "hidden"}
			if (data.lowfuel == 1 ) {fuel.style.backgroundImage = fuelred} else {fuel.style.backgroundImage = fuelwhite}
		div.style.color = "#FFFFFF";
		$scope.data.dategauge = data.dategauge
			if (data.kneel == 1 ) {div.style.color = remindcolour;$scope.data.dategauge = "BUS KNEELED"}
			if (data.doorLeverF1 == 1 || data.doorLeverF2 == 1 || data.doorLeverR1 == 1 || data.doorLeverR2 == 1) {div.style.color = remindcolour;$scope.data.dategauge = "DOOR OPENED"}
			if (data.wheelchairrampF == 1 || data.wheelchairrampR == 1) {div.style.color = remindcolour;$scope.data.dategauge = "WCH RAMP OPENED"}
			if (data.enginedoor == 1 ) {div.style.color = remindcolour;$scope.data.dategauge = "ENGINE DOOR OPENED"}
		ret.style.transform = "rotate(" + retang + "deg)";
		if (data.state == 0) {rettext.style.visibility = "hidden"} else {rettext.style.visibility = "visible"}
		if (data.fueltype == 1) {
			document.getElementById("evbatbarOverflow").style.visibility = "hidden";
			document.getElementById("evbatneedle").style.visibility = "hidden";
			hbatgauge.style.visibility = "visible";
			document.getElementById("powergauges").style.visibility = "visible";
			batang = parseInt(90*data.batteryLevel);
			if (data.batteryLevel <= 0.2) {
				document.getElementById("batneedle").style.backgroundImage = needlered;
				document.getElementById("batbar").style.borderLeftColor = "rgba(204,51,0,0.2)";
				bat.style.backgroundImage = batred;
			} else {
				document.getElementById("batneedle").style.backgroundImage = needledef;
				document.getElementById("batbar").style.borderLeftColor = "rgba(105,94,152,0.2)";
				bat.style.backgroundImage = batwhite;
			}
			pwrang = parseInt(45*data.kw/500);
			if (pwrang > 45) {pwrang = 45}
			if (pwrang < -45) {pwrang = -45}
			pwr.style.transform = "rotate(" + (pwrang-45) + "deg)";
			chg.style.transform = "rotate(" + (pwrang+45) + "deg)";
			if (data.kw >= 1) {
				pwrtext.style.opacity = 1;
				chgtext.style.opacity = 0.2;
			} else if (data.kw <= -1) {
				pwrtext.style.opacity = 0.2;
				chgtext.style.opacity = 1;
			} else {
				pwrtext.style.opacity = 0.2;
				chgtext.style.opacity = 0.2;
			}
		} else if (data.fueltype == 2) {
			hbatgauge.style.visibility = "hidden";
			document.getElementById("rpmbarOverflow").style.visibility = "hidden";
			document.getElementById("rpm").style.visibility = "hidden";
			document.getElementById("centergauges").style.visibility = "hidden";
			document.getElementById("evpowergauges").style.visibility = "visible";
			evbat.style.visibility = "visible";
			document.getElementById("evbatbarOverflow").style.visibility = "visible";
			document.getElementById("evbatneedle").style.visibility = "visible";
			document.getElementById("evbatneedle").style.transform = "rotate(" + evbatang + "deg)";
			document.getElementById("evbatbar").style.transform = "rotate(" + (evbatang-135) + "deg)";
			if (data.fuel <= 0.2) {
				document.getElementById("evbatneedle").style.backgroundImage = needlered;
				document.getElementById("evbatbar").style.borderLeftColor = "rgba(204,51,0,0.2)";
				evbat.style.backgroundImage = batred
			} else {
				document.getElementById("evbatneedle").style.backgroundImage = needledef;
				document.getElementById("evbatbar").style.borderLeftColor = "rgba(105,94,152,0.2)";
				evbat.style.backgroundImage = batwhite
			}
			pwrang = parseInt(-90*data.kwev/400);
			if (pwrang > 90) {pwrang = 90}
			if (pwrang < -90) {pwrang = -90}
			evpwr.style.transform = "rotate(" + (pwrang+45) + "deg)";
			evchg.style.transform = "rotate(" + (pwrang-45) + "deg)";
		} else {
			document.getElementById("evbatbarOverflow").style.visibility = "hidden";
			document.getElementById("evbatneedle").style.visibility = "hidden";
			hbatgauge.style.visibility = "hidden";
			if (data.battery == 1 ) {bat.style.backgroundImage = batred} else {bat.style.backgroundImage = batwhite}
		}
		document.getElementById("batbar").style.transform = "rotate(" + (batang-225) + "deg)";
		document.getElementById("batneedle").style.transform = "rotate(" + (batang-180) + "deg)";
        }
		else {
		$scope.data.speedometergauge = " "
		$scope.data.dategauge = " "
		$scope.data.odometer = " "
		}

    }
	)
 }
});    
