-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"
M.relevantDevice = nil

local htmlTexture = require("htmlTexture")

local min = math.min
local max = math.max

local gaugesScreenName = nil
local htmlPath = nil

local updateFPS = 30
local updateTimer = 0

local lefthanddrive

local function updateGFX(dt)
    local data = {}
	
  updateTimer = updateTimer + dt
  if updateTimer > (1 / updateFPS) then
	data.lefthanddrive = lefthanddrive
	
	data.enginerunning = electrics.values["engineRunning"]
	
	data.kneel = electrics.values["kneel"]
	data.rideheight = electrics.values["rideheight"]
	data.doorLeverF1 = electrics.values["doorLeverF1"]
	data.doorLeverF2 = electrics.values["doorLeverF2"]
	data.doorLeverR1 = electrics.values["doorLeverR1"]
	data.doorLeverR2 = electrics.values["doorLeverR2"]
	data.wheelchairrampF = electrics.values["wheelchairrampF"]
	data.wheelchairrampR = electrics.values["wheelchairrampR"]
	data.enginedoor = electrics.values["enginedoor"]

    --dump(data)
    htmlTexture.call(gaugesScreenName, "updateData", data)
    updateTimer = 0
  end
end

local function init(jbeamData)
	gaugesScreenName = jbeamData.materialName
	htmlPath = jbeamData.htmlPath
	local width = jbeamData.textureWidth or 256
	local height = jbeamData.textureHeight or 128
	lefthanddrive = jbeamData.lefthanddrive or 0

    htmlTexture.create(gaugesScreenName, htmlPath, width, height, updateFPS, "automatic")
end

M.init = init
M.updateGFX = updateGFX

return M
