-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"
M.relevantDevice = nil

local htmlTexture = require("htmlTexture")

local min = math.min
local max = math.max

local hudScreenName = nil
local htmlPath = nil

local updateFPS = 30
local updateTimer = 0

local function updateGFX(dt)
    local data = {}

  updateTimer = updateTimer + dt
  if updateTimer > (1 / updateFPS) then
	data.enginerunning = electrics.values["engineRunning"]
	data.hudunit = electrics.values["gaugeunit"]
	data.speedometerhud = electrics.values["wheelspeed"] * 3.6
	data.signal_l_hud = electrics.values["signal_L"]
	data.signal_r_hud = electrics.values["signal_R"]
	
	data.kneel = electrics.values["kneel"]
	data.doorLeverF1 = electrics.values["doorLeverF1"]
	data.doorLeverF2 = electrics.values["doorLeverF2"]
	data.doorLeverR1 = electrics.values["doorLeverR1"]
	data.doorLeverR2 = electrics.values["doorLeverR2"]
	data.wheelchairrampF = electrics.values["wheelchairrampF"]
	data.wheelchairrampR = electrics.values["wheelchairrampR"]
	data.enginedoor = electrics.values["enginedoor"]
	
    --dump(data)
    htmlTexture.call(hudScreenName, "updateData", data)
    updateTimer = 0
  end
end

local function init(jbeamData)
	hudScreenName = jbeamData.materialName
	htmlPath = jbeamData.htmlPath
	local width = jbeamData.textureWidth or 256
	local height = jbeamData.textureHeight or 256

    htmlTexture.create(hudScreenName, htmlPath, width, height, updateFPS, "automatic")
	
end

M.init = init
M.updateGFX = updateGFX

return M
